	.module main
	
	.area CSEG (CODE,CON)
	ljmp	startup
	ljmp	_int0_isr
	.ds	5
	ljmp	_timer0_isr
	.ds	5
	ljmp	_int1_isr
	.ds	5
	ljmp	_timer1_isr
	.ds	5
	ljmp	_ser0_isr
	.ds	5
	ljmp	_timer2_isr
	.ds	5
	ljmp	_resume_isr
	.ds	5
	ljmp	_ser1_isr
	.ds	5
	ljmp	_usb_isr  ; this jump target is mutated by Autovector
	.ds	5
	ljmp	_i2c_isr
	.ds	5
	ljmp	_int4_isr
	.ds	5
	ljmp	_int5_isr
	.ds	5
	ljmp	_int6_isr
.ds	0x9a

_usb_isr:  ; Autovector table
	ljmp	_usb_sudav_isr
	.ds	1
	ljmp	_usb_sof_isr
	.ds	1
	ljmp	_usb_sutok_isr
	.ds	1
	ljmp	_usb_suspend_isr
	.ds	1
	ljmp	_usb_usbreset_isr
	.ds	1
	reti
	.ds	3
	ljmp	_usb_ep0in_isr
	.ds	1
	ljmp	_usb_ep0out_isr
	.ds	1
	ljmp	_usb_ep1in_isr
	.ds	1
	ljmp	_usb_ep1out_isr
	.ds	1
	ljmp	_usb_ep2in_isr
	.ds	1
	ljmp	_usb_ep2out_isr
	.ds	1
	ljmp	_usb_ep3in_isr
	.ds	1
	ljmp	_usb_ep3out_isr
	.ds	1
	ljmp	_usb_ep4in_isr
	.ds	1
	ljmp	_usb_ep4out_isr
	.ds	1
	ljmp	_usb_ep5in_isr
	.ds	1
	ljmp	_usb_ep5out_isr
	.ds	1
	ljmp	_usb_ep6in_isr
	.ds	1
	ljmp	_usb_ep6out_isr
	.ds	1
	ljmp	_usb_ep7in_isr
	.ds	1
	ljmp	_usb_ep7out_isr

	.area	GSINIT (CODE)
	.area	GSFINAL (CODE)
	.area	GSINIT (CODE)
startup:
	;; allow for all 4 banks to be used (otherwise use eg. 7)
	;mov	sp,#31
	;; set stack to indirect data area
	mov	sp,#0x7f
	;lcall	__sdcc_external_startup
	;mov	a,dpl
	;jz	__sdcc_init_data
	;ljmp	__sdcc_program_startup
__sdcc_init_data:

	.area	GSFINAL (CODE)
__sdcc_program_startup:
	lcall	_ezusbmain
	ajmp	.
